module misr    (
out             ,  // Output of the counter
in		,  // Input of the MISR
enable          ,  // Enable  for counter
clk             ,  // clock input
reset              // reset input
);

output [2:0] out;
input [2:0] in;
input enable, clk, reset;
reg [2:0] out;
wire        linear_feedback;

assign linear_feedback = (out[1] ^ out[2]);

always @(posedge clk)
if (reset) begin // active high reset
  out <= 3'b111 ;
end else if (enable) begin
  out <= {out[1] ^ in [2], out[0] ^ in[1], linear_feedback ^ in[0]};
end 

endmodule
