/******************************************************************************
**  Module:                cpu_edt_top
**  Tessent Shell version: 2013.4
**  IP version:            5
**  Date:                  Mon Dec 30 11:40:48 2013
******************************************************************************/

module cpu_edt_top (clk,
                    reset,
                    paddr,
                    pdata,
                    portain,
                    portbout,
                    portcout,
                    expdin,
                    expdout,
                    expaddr,
                    expread,
                    expwrite,
                    debugw,
                    debugpc,
                    debugstatus,
                    scan_en,
                    edt_clock,
                    edt_update,
                    edt_bypass,
                    edt_channels_in1,
                    edt_channels_in2,
                    edt_channels_in3,
                    edt_channels_in4,
                    edt_channels_out1,
                    edt_channels_out2,
                    edt_channels_out3,
                    edt_channels_out4);

   input         clk;
   input         reset;
   output [10:0] paddr;
   input  [11:0] pdata;
   input  [ 7:0] portain;
   output [ 7:0] portbout;
   output [ 7:0] portcout;
   input  [ 7:0] expdin;
   output [ 7:0] expdout;
   output [ 6:0] expaddr;
   output        expread;
   output        expwrite;
   output [ 7:0] debugw;
   output [10:0] debugpc;
   output [ 7:0] debugstatus;
   input         scan_en;
   input         edt_clock;
   input         edt_update;
   input         edt_bypass;
   input         edt_channels_in1;
   input         edt_channels_in2;
   input         edt_channels_in3;
   input         edt_channels_in4;
   output        edt_channels_out1;
   output        edt_channels_out2;
   output        edt_channels_out3;
   output        edt_channels_out4;


   wire   [ 7:0] portbout_local;
   wire   [ 7:0] portcout_local;
   wire   [ 7:0] debugw_local;
   wire   [10:0] debugpc_local;
   wire   [11:0] debuginst;
   wire   [ 7:0] debugstatus_local;
   wire   [19:0] edt_scan_in;
   wire   [19:0] edt_scan_out;

   assign edt_scan_out[0]  = debugpc_local[10];
   assign edt_scan_out[1]  = debugw_local[0];
   assign edt_scan_out[2]  = debuginst[0];
   assign edt_scan_out[3]  = debuginst[11];
   assign edt_scan_out[4]  = debuginst[7];
   assign edt_scan_out[5]  = debuginst[6];
   assign edt_scan_out[6]  = debuginst[9];
   assign edt_scan_out[7]  = debuginst[10];
   assign edt_scan_out[8]  = debuginst[8];
   assign edt_scan_out[9]  = debuginst[1];
   assign edt_scan_out[10] = debuginst[3];
   assign edt_scan_out[11] = debuginst[4];
   assign edt_scan_out[12] = debuginst[2];
   assign edt_scan_out[13] = debugstatus_local[6];
   assign edt_scan_out[14] = debugstatus_local[5];
   assign edt_scan_out[15] = debugpc_local[0];
   assign edt_scan_out[16] = debuginst[5];
   assign edt_scan_out[17] = debugstatus_local[0];
   assign edt_scan_out[18] = portbout_local[0];
   assign edt_scan_out[19] = portcout_local[0];
   assign portbout[7]      = portbout_local[7];
   assign portbout[6]      = portbout_local[6];
   assign portbout[5]      = portbout_local[5];
   assign portbout[4]      = portbout_local[4];
   assign portbout[3]      = portbout_local[3];
   assign portbout[2]      = portbout_local[2];
   assign portbout[1]      = portbout_local[1];
   assign portcout[7]      = portcout_local[7];
   assign portcout[6]      = portcout_local[6];
   assign portcout[5]      = portcout_local[5];
   assign portcout[4]      = portcout_local[4];
   assign portcout[3]      = portcout_local[3];
   assign portcout[2]      = portcout_local[2];
   assign portcout[1]      = portcout_local[1];
   assign debugw[7]        = debugw_local[7];
   assign debugw[6]        = debugw_local[6];
   assign debugw[5]        = debugw_local[5];
   assign debugw[4]        = debugw_local[4];
   assign debugw[3]        = debugw_local[3];
   assign debugw[2]        = debugw_local[2];
   assign debugw[1]        = debugw_local[1];
   assign debugpc[9]       = debugpc_local[9];
   assign debugpc[8]       = debugpc_local[8];
   assign debugpc[7]       = debugpc_local[7];
   assign debugpc[6]       = debugpc_local[6];
   assign debugpc[5]       = debugpc_local[5];
   assign debugpc[4]       = debugpc_local[4];
   assign debugpc[3]       = debugpc_local[3];
   assign debugpc[2]       = debugpc_local[2];
   assign debugpc[1]       = debugpc_local[1];
   assign debugstatus[7]   = debugstatus_local[7];
   assign debugstatus[4]   = debugstatus_local[4];
   assign debugstatus[3]   = debugstatus_local[3];
   assign debugstatus[2]   = debugstatus_local[2];
   assign debugstatus[1]   = debugstatus_local[1];

   cpu cpu_i (.clk(clk),
              .reset(reset),
              .paddr(paddr),
              .pdata(pdata),
              .portain(portain),
              .portbout(portbout_local),
              .portcout(portcout_local),
              .expdin(expdin),
              .expdout(expdout),
              .expaddr(expaddr),
              .expread(expread),
              .expwrite(expwrite),
              .debugw(debugw_local),
              .debugpc(debugpc_local),
              .debuginst(debuginst),
              .debugstatus(debugstatus_local),
              .scan_in1(edt_scan_in[0]),
              .scan_in2(edt_scan_in[1]),
              .scan_in3(edt_scan_in[2]),
              .scan_in4(edt_scan_in[3]),
              .scan_in5(edt_scan_in[4]),
              .scan_in6(edt_scan_in[5]),
              .scan_in7(edt_scan_in[6]),
              .scan_in8(edt_scan_in[7]),
              .scan_in9(edt_scan_in[8]),
              .scan_in10(edt_scan_in[9]),
              .scan_in11(edt_scan_in[10]),
              .scan_in12(edt_scan_in[11]),
              .scan_in13(edt_scan_in[12]),
              .scan_in14(edt_scan_in[13]),
              .scan_in15(edt_scan_in[14]),
              .scan_in16(edt_scan_in[15]),
              .scan_in17(edt_scan_in[16]),
              .scan_in18(edt_scan_in[17]),
              .scan_in19(edt_scan_in[18]),
              .scan_in20(edt_scan_in[19]),
              .scan_en(scan_en));

   cpu_edt cpu_edt_i (.edt_clock(edt_clock),
                      .edt_update(edt_update),
                      .edt_bypass(edt_bypass),
                      .edt_channels_in({edt_channels_in4, edt_channels_in3, edt_channels_in2, edt_channels_in1}),
                      .edt_channels_out({edt_channels_out4, edt_channels_out3, edt_channels_out2, edt_channels_out1}),
                      .edt_scan_in(edt_scan_in),
                      .edt_scan_out(edt_scan_out));

endmodule


